using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using nMail;

namespace csmail
{
    public partial class FormOption : Form
    {
        public FormOption()
        {
            InitializeComponent();
        }

        private void comboSmtpSsl_SelectedIndexChanged(object sender, EventArgs e)
        {
			if(comboSmtpSsl.SelectedIndex == 0 || comboSmtpSsl.SelectedIndex == 3) 
			{
				textSmtpPort.Text = nMail.Smtp.StandardPortNo.ToString();
			}
			else
			{
				textSmtpPort.Text = nMail.Smtp.StandardSslPortNo.ToString();
			}
        }

        private void comboPop3Ssl_SelectedIndexChanged(object sender, EventArgs e)
        {
			if(comboPop3Ssl.SelectedIndex == 0 || comboPop3Ssl.SelectedIndex == 3) 
			{
				textPop3Port.Text = nMail.Pop3.StandardPortNo.ToString();
			}
			else
			{
				textPop3Port.Text = nMail.Pop3.StandardSslPortNo.ToString();
			}
        }

		public string Smtp
		{
			get
			{
				return textSmtp.Text;
			}
			set
			{
				textSmtp.Text = value;
			}
		}

		public int SmtpPort
		{
			get
			{
				return int.Parse(textSmtpPort.Text);
			}
			set
			{
				textSmtpPort.Text = value.ToString();
			}
		}

		public int SmtpSsl
		{
			get
			{
				if(comboSmtpSsl.SelectedIndex == 1)
				{
					return nMail.Smtp.SSL3;
				}
				else if(comboSmtpSsl.SelectedIndex == 2)
				{
					return nMail.Smtp.TLS1;
				}
				else if(comboSmtpSsl.SelectedIndex == 3)
				{
					return nMail.Smtp.STARTTLS;
				}
				else
				{
					return 0;
				}
			}
			set
			{
				if(value == nMail.Smtp.SSL3)
				{
					comboSmtpSsl.SelectedIndex = 1;
				}
				else if(value == nMail.Smtp.TLS1)
				{
					comboSmtpSsl.SelectedIndex = 2;
				}
				else if(value == nMail.Smtp.STARTTLS)
				{
					comboSmtpSsl.SelectedIndex = 3;
				}
				else
				{
					comboSmtpSsl.SelectedIndex = 0;
				}
			}
		}

		public int SmtpAuth
		{
			get
			{
				if(comboSmtpAuth.SelectedIndex == 3)
				{
					return nMail.Smtp.AuthCramMd5;
				}
				else
				{
					return comboSmtpAuth.SelectedIndex;
				}
			}
			set
			{
				if(value == nMail.Smtp.AuthCramMd5)
				{
					comboSmtpAuth.SelectedIndex = 3;
				}
				else
				{
					comboSmtpAuth.SelectedIndex = value;
				}
			}
		}

		public string Pop3
		{
			get
			{
				return textPop3.Text;
			}
			set
			{
				textPop3.Text = value;
			}
		}

		public int Pop3Ssl
		{
			get
			{
				if(comboPop3Ssl.SelectedIndex == 1)
				{
					return nMail.Pop3.SSL3;
				}
				else if(comboPop3Ssl.SelectedIndex == 2)
				{
					return nMail.Pop3.TLS1;
				}
				else if(comboPop3Ssl.SelectedIndex == 3)
				{
					return nMail.Pop3.STARTTLS;
				}
				else
				{
					return 0;
				}
			}
			set
			{
				if(value == nMail.Pop3.SSL3)
				{
					comboPop3Ssl.SelectedIndex = 1;
				}
				else if(value == nMail.Pop3.TLS1)
				{
					comboPop3Ssl.SelectedIndex = 2;
				}
				else if(value == nMail.Pop3.STARTTLS)
				{
					comboPop3Ssl.SelectedIndex = 3;
				}
				else
				{
					comboPop3Ssl.SelectedIndex = 0;
				}
			}
		}

		public int Pop3Port
		{
			get
			{
				return int.Parse(textPop3Port.Text);
			}
			set
			{
				textPop3Port.Text = value.ToString();
			}
		}

		public string Address
		{
			get
			{
				return textAddress.Text;
			}
			set
			{
				textAddress.Text = value;
			}
		}

		public bool Apop
		{
			get
			{
				return checkApop.Checked;
			}
			set
			{
				checkApop.Checked = value;
			}
		}
    }
}