Public Class FormProperty

    Private Sub FormProperty_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		Dim no As Integer
		For no = 0 To PathList.Count - 1
            AddTree(CStr(PathList(no)), CStr(TextList(no)))
		Next
		If Not TreeMime.TopNode Is Nothing Then
			TreeMime.TopNode.Expand()
		End If
    End Sub

	Public Function SearchNode(ByVal node As TreeNode, ByVal path As String) As TreeNode
		If not node is Nothing Then
			For Each tn As TreeNode In node.Nodes
				Dim ctn As TreeNode
				ctn = SearchNode(tn, path)
				if not ctn Is Nothing Then
					return ctn
				End If
				If Not tn.Tag Is Nothing Then
					Dim data As String = CType(tn.Tag, String)
                    Debug.WriteLine(tn.Text + ":" + data)
					If string.Compare(data, path, true) = 0 Then
						return tn
					End If
				End If
			Next
		End If
		return Nothing
    End Function

    Public Sub AddTree(ByVal name As String, ByVal text As String)
        Dim no As Integer
        Dim node As TreeNode
        Dim parent_node As TreeNode
        Dim path As String
        Dim folder As String() = name.Split("."c)

        parent_node = TreeMime.TopNode
        TreeMime.PathSeparator = "."
        For no = 0 To folder.Length - 1
            path = String.Join(".", folder, 0, no + 1)
            node = SearchNode(TreeMime.TopNode, path)
            If node Is Nothing Then
                node = New TreeNode(Text)
                node.Tag = path
                If parent_node Is Nothing Then
                    TreeMime.Nodes.Add(node)
                Else
                    parent_node.Nodes.Add(node)
                    parent_node.Expand()
                End If
            End If
            parent_node = node
        Next
    End Sub

    Public WriteOnly Property Header() As String
        Set(ByVal Value As String)
            TextHeader.Text = Value
        End Set
    End Property

	Public Sub AddTreeItem(ByVal path As String, ByVal text As String)
		PathList.Add(path)
		TextList.Add(text)
	End Sub

	Private PathList As ArrayList = New ArrayList()
	Private TextList As ArrayList = New ArrayList()

End Class